package com.xunmei.system.service.impl;

import java.util.List;

import com.xunmei.common.core.utils.DateUtils;
import com.xunmei.system.api.domain.SysOrg;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import com.xunmei.system.service.ISysOrgService;

import java.util.Arrays;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.xunmei.common.core.web.page.TableDataInfo;
import com.xunmei.system.mapper.SysOrgExtendMapper;
import com.xunmei.system.domain.SysOrgExtend;
import com.xunmei.system.service.ISysOrgExtendService;

/**
 * 机构扩展Service业务层处理
 *
 * @author xunmei
 * @date 2023-08-16
 */
@Service
public class SysOrgExtendServiceImpl extends ServiceImpl<SysOrgExtendMapper, SysOrgExtend> implements ISysOrgExtendService {
    @Autowired
    private SysOrgExtendMapper sysOrgExtendMapper;
    @Autowired
    private ISysOrgService orgService;

    @Override
    public TableDataInfo<SysOrgExtend> selectPage(SysOrgExtend sysOrgExtend) {

        //未删除
//        sysOrgExtend.setDeleted(0L);
        Page<SysOrgExtend> page;
        //分页
        if (sysOrgExtend.getPageNum() != null && sysOrgExtend.getPageSize() != null) {
            page = new Page<>(sysOrgExtend.getPageNum(), sysOrgExtend.getPageSize());
        } else {
            page = new Page<>();
        }
        //查询条件
        QueryWrapper<SysOrgExtend> query = new QueryWrapper<>(sysOrgExtend);
        //下穿
        if (sysOrgExtend.getCheckSub()) {
            List<Long> ids = orgService.selectCheckSubOrgIdList(sysOrgExtend.getOrgId());
            //清空前端传递的org_id
            sysOrgExtend.setOrgId(null);
            //添加in条件
            query.in("org_id", ids);
        }
        //时间范围查询
        if (sysOrgExtend.getParams().get("beginTime") != null && sysOrgExtend.getParams().get("endTime") != null) {
            query.between("create_time", sysOrgExtend.getParams().get("beginTime"), sysOrgExtend.getParams().get("endTime"));
        }
        //获取数据
        page = sysOrgExtendMapper.selectPage(page, query);
        return TableDataInfo.build(page);


    }


    /**
     * 查询机构扩展
     *
     * @param id 机构扩展主键
     * @return 机构扩展
     */
    @Override
    public SysOrgExtend selectSysOrgExtendById(Long id) {
        return sysOrgExtendMapper.selectById(id);
    }

    @Override
    public SysOrgExtend selectSysOrgExtendByOrgId(Long id) {
        return sysOrgExtendMapper.selectOne(new QueryWrapper<SysOrgExtend>().eq("org_id", id));
    }

    /**
     * 查询机构扩展列表
     *
     * @param sysOrgExtend 机构扩展
     * @return 机构扩展
     */
    @Override
    public List<SysOrgExtend> selectSysOrgExtendList(SysOrgExtend sysOrgExtend) {
        return sysOrgExtendMapper.selectList(new QueryWrapper<>(sysOrgExtend));
    }

    /**
     * 新增机构扩展
     *
     * @param sysOrgExtend 机构扩展
     * @return 结果
     */
    @Override
    public int insertSysOrgExtend(SysOrgExtend sysOrgExtend) {
        sysOrgExtend.setCreateTime(DateUtils.getNowDate());
        return sysOrgExtendMapper.insert(sysOrgExtend);
    }

    /**
     * 修改机构扩展
     *
     * @param sysOrgExtend 机构扩展
     * @return 结果
     */
    @Override
    public int updateSysOrgExtend(SysOrgExtend sysOrgExtend) {
        sysOrgExtend.setUpdateTime(DateUtils.getNowDate());
        return sysOrgExtendMapper.updateById(sysOrgExtend);
    }

    /**
     * 批量删除机构扩展
     *
     * @param ids 需要删除的机构扩展主键
     * @return 结果
     */
    @Override
    public int deleteSysOrgExtendByIds(Long[] ids) {
        return sysOrgExtendMapper.deleteBatchIds(Arrays.asList((ids)));
    }

    /**
     * 删除机构扩展信息
     *
     * @param id 机构扩展主键
     * @return 结果
     */
    @Override
    public int deleteSysOrgExtendById(Long id) {
        return sysOrgExtendMapper.deleteById(id);
    }
}
